
	.title  "RX+display"	; Titolo del programma 
	.vers   "ST62E10"	; Microprocessore usato  
	.w_on             	; Abilita la memoria a finestre
	;       8 Mhz		;19/05/1998  By Vittorio Crapella
;----------------------------------------------------------------------------
;|                       VARIABILI DEL MICROPROCESSORE                      |

a       .def    0ffh    ;Registro accumulatore
x       .def    080h    ;Registro x 
y       .def    081h    ;Registro y
v       .def    082h    ;Registro v
w       .def    083h    ;Registro w
port_a  .def    0c0h    ;Registro Dati porta A 
port_b  .def    0c1h    ;Registro Dati porta B
port_c  .def    0c2h    ;Registro Dati porta C
pdir_a  .def    0c4h    ;Registro Direzione porta A
pdir_b  .def    0c5h    ;Registro Direzione porta B
pdir_c  .def    0c6h    ;Registro Direzione porta C
popt_a  .def    0cch    ;Registro Opzioni porta A
popt_b  .def    0cdh    ;Registro Opzioni porta B
popt_c  .def    0ceh    ;Registro Opzioni porta C
ior     .def    0c8h    ;Registro Opzioni per le Interruzioni
addr    .def    0d0h    ;Registro Dati dell'A/D converter
adcr    .def    0d1h    ;Registro di Controllo dell'A/D converter
psc     .def    0d2h    ;Registro per il Prescaler del Timer
tcr     .def    0d3h    ;Registro Dati del Timer
tscr    .def    0d4h    ;Registro TSCR del Timer 
wdog    .def    0d8h    ;Registro del WatchDog
drw     .def    0c9h    ;Registro della zona dati ROM (Rom Data Window)
;----------------------------------------------------------------------------
;|                   VARIABILI usate da questo PROGRAMMA                     |
;----------------------------------------------------------------------------


aa	.def	084h
decimi	.def	085h
unita	.def	086h
decine	.def	087h
resto	.def	088h
risul	.def	089h
xx	.def	08ah
        .org    0880h     

inizio                    

        ldi     wdog,0ffh               ; Carico il Watch-Dog.
;***  Setta la porta A 
	ldi     pdir_a,11111111b        ;dipsonibili solo pa0,1,2,3 verso CA3161
	ldi     popt_a,11111111b        ; tutti ouput
	ldi     port_a,11111111b       
					
;***  Setta la porta B 
	ldi     pdir_b,00000111b       ;pa0,1,2  output 
	ldi     popt_b,00000111b       ;pb3 in rx
	ldi     port_b,00000111b        ; rimanenti non utilizzati conf. input

	reti                  
	jp      main   

;****************************************************************************
;***                     GESTORI di INTERRUPT                             ***
;****************************************************************************

ad_int 	reti
tim_int reti
	
BC_int  reti
A_int   reti

nmi_int 
	reti

media 	add	a,resto			;somma il precedente valore con il nuovo
	jrnc	etic2			;se non c riporto salta
	inc	risul			;altrimenti incrementa 
etic2	ld	resto,a
	ld	a,xx			;verifica se ha eseguito 255 conversioni
	jrz	etic4			;se si salta 
	dec 	xx			;altrimenti un conversione in meno
	ret
etic4	ld	a,resto			;arrotonda
	cpi	a,127
	jrc	etic3			;se a < 127 salta
	inc	risul			;altrimenti arrotonda incrementando risul
etic3	ld	a,risul			;valore  mediato 255 volte va  in a

	ldi	xx,5
	call	div
	ld	a,resto
	sla	a			;moltiplica per 2
	ld	decimi,a
	ld	a,risul
	ldi	xx,10
	call	div
	cpi	a,0
        jrnz    no0
	ldi	a,15
no0	ld	decine,a
	ld	a,resto
	ld	unita,a
	clr	resto
	clr	risul
	ldi 	xx,255
	ret

div	clr 	w
	ldi	wdog,255
	cp 	a,xx			;se a< div salta
	jrc	ok
sub_	sub 	a,xx			;sottrae x ad a
	inc 	w			;conta quante volte ci sta x in a
	ldi 	wdog,255
	cp 	a,xx			
	jrnc 	sub_			;se a >= salta e continua a sottrarre
ok	ld 	resto,a			;resto       UNITA
	ld 	a,w	 		;risultato
        ld      risul,a                 ; DECINE
	ret




;DISPLAY

mux     ld      aa,a
        ldi     port_b,00001111b        ;spegne display
	ld	a,v
	cpi	a,0
        jrnz    uno_
	ld	a,decimi
	ld	port_a,a
	ldi	port_b,0001011b
	jp	normal
uno_    cpi    a,1
	jrnz	due
	ld	a,unita
        ld      port_a,a
	ldi	port_b,00001101b
	jp	normal
due	ld	a,decine
	ld	port_a,a
	ldi	port_b,0001110b
	ldi	v,255
normal	inc	v
	ld	a,aa
        ret

;PROGRAMMA PRINCIPALE RX

main	clr	resto
	clr	risul
	ldi 	xx,255
main_	ldi 	wdog,255		;RICEVE UN BYTE
	ldi	w,25			;resta in questo loop fino a che input
testa   jrs     3,port_b,main_           ;da alto torna basso e permane + di un T
	dec	w			;per assicurarsi che sia un nuovo byte
	jrnz	testa
	ldi	x,8			;numero bit da ricevere x confronto
rx      ldi     wdog,255
        jrr     3,port_b,rx
        call    mux
	ldi	w,6		       ;predispone per la campionatura a 1/2 T
decr	dec	w
	jrnz	decr 
        jrr     3,port_b,zero           ;se dopo 1/2 T e` 0 salta
uno	set	0,a			;altrimenti setta bit0 di a
	dec	x			;conta un bit ricevuto
	jrz	out			;se sono finiti salta
	sla	a			;altrimenti sposta a sinistra bit0 e prepara
resta   jrs     3,port_b,resta          ;per il prossimo
        jp      rx                      ;se linea =1 resta altrimenti input
out	call 	media
	jp	main_			;ricomincia per altro byte
zero	res	0,a			;bit0= 0
	dec	x
        jrnz    slaa
        jp      out                     ;se sono finiti salta
slaa    sla     a                       ;altrimenti sposta a sinistra e libera x prossimo
        jp      rx                      ;ne aspetta un altro
	
;****************************************************************************
;***                   VETTORI DI INTERRUPTS                              ***
;****************************************************************************

	.org    0ff0h
	jp      ad_int  	;A/D int        vector #4
	jp      tim_int 	;timer int      vector #3
	jp      BC_int  	;port B & C int vector #2
	jp      A_int   	;port A int     vector #1
	.org    0ffch
	jp      nmi_int 	;nmi int        vector #0
	jp    	inizio  	;reset vector
	.end     		; Fine del programma
